]> git.proxmox.com Git - mirror_ubuntu-jammy-kernel.git/blame - scripts/link-vmlinux.sh
scripts: sphinx-pre-install: add required ctex dependency
[mirror_ubuntu-jammy-kernel.git] / scripts / link-vmlinux.sh
CommitLineData
1f2bfbd0 1#!/bin/sh
b2441318 2# SPDX-License-Identifier: GPL-2.0
1f2bfbd0
SR
3#
4# link vmlinux
5#
d151e971
MY
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
1f2bfbd0
SR
11#
12# vmlinux
13# ^
14# |
d151e971
MY
15# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
1f2bfbd0 17# |
3a166fc2
NP
18# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
1f2bfbd0
SR
21# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
3ec8a5b3
MY
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
1f2bfbd0
SR
37# Nice output in kbuild format
38# Will be supressed by "make -s"
39info()
40{
c39013ee 41 printf " %-7s %s\n" "${1}" "${2}"
1f2bfbd0
SR
42}
43
a8cccdd9
ST
44# Generate a linker script to ensure correct ordering of initcalls.
45gen_initcalls()
46{
47 info GEN .tmp_initcalls.lds
48
49 ${PYTHON} ${srctree}/scripts/jobserver-exec \
50 ${PERL} ${srctree}/scripts/generate_initcall_order.pl \
51 ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS} \
52 > .tmp_initcalls.lds
53}
54
38e89184
ST
55# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
56# .tmp_symversions.lds
57gen_symversions()
58{
59 info GEN .tmp_symversions.lds
60 rm -f .tmp_symversions.lds
61
62 for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
63 if [ -f ${o}.symversions ]; then
64 cat ${o}.symversions >> .tmp_symversions.lds
65 fi
66 done
67}
68
1f2bfbd0
SR
69# Link of vmlinux.o used for section mismatch analysis
70# ${1} output file
71modpost_link()
72{
a5967db9 73 local objects
38e89184 74 local lds=""
a5967db9 75
6358d6e8 76 objects="--whole-archive \
d151e971 77 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
78 --no-whole-archive \
79 --start-group \
80 ${KBUILD_VMLINUX_LIBS} \
81 --end-group"
82
dc5723b0 83 if [ -n "${CONFIG_LTO_CLANG}" ]; then
a8cccdd9
ST
84 gen_initcalls
85 lds="-T .tmp_initcalls.lds"
86
38e89184
ST
87 if [ -n "${CONFIG_MODVERSIONS}" ]; then
88 gen_symversions
89 lds="${lds} -T .tmp_symversions.lds"
90 fi
91
dc5723b0
ST
92 # This might take a while, so indicate that we're doing
93 # an LTO link
94 info LTO ${1}
95 else
96 info LD ${1}
97 fi
98
38e89184 99 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
1f2bfbd0
SR
100}
101
6804c1af
PZ
102objtool_link()
103{
b1a1a1a0 104 local objtoolcmd;
6804c1af
PZ
105 local objtoolopt;
106
b1a1a1a0
ST
107 if [ "${CONFIG_LTO_CLANG} ${CONFIG_STACK_VALIDATION}" = "y y" ]; then
108 # Don't perform vmlinux validation unless explicitly requested,
109 # but run objtool on vmlinux.o now that we have an object file.
110 if [ -n "${CONFIG_UNWINDER_ORC}" ]; then
111 objtoolcmd="orc generate"
112 fi
113
114 objtoolopt="${objtoolopt} --duplicate"
115
116 if [ -n "${CONFIG_FTRACE_MCOUNT_USE_OBJTOOL}" ]; then
117 objtoolopt="${objtoolopt} --mcount"
118 fi
119 fi
120
6804c1af 121 if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
b1a1a1a0
ST
122 objtoolopt="${objtoolopt} --noinstr"
123 fi
124
125 if [ -n "${objtoolopt}" ]; then
126 if [ -z "${objtoolcmd}" ]; then
127 objtoolcmd="check"
128 fi
129 objtoolopt="${objtoolopt} --vmlinux"
6804c1af
PZ
130 if [ -z "${CONFIG_FRAME_POINTER}" ]; then
131 objtoolopt="${objtoolopt} --no-fp"
132 fi
b1a1a1a0 133 if [ -n "${CONFIG_GCOV_KERNEL}" ] || [ -n "${CONFIG_LTO_CLANG}" ]; then
6804c1af
PZ
134 objtoolopt="${objtoolopt} --no-unreachable"
135 fi
136 if [ -n "${CONFIG_RETPOLINE}" ]; then
137 objtoolopt="${objtoolopt} --retpoline"
138 fi
139 if [ -n "${CONFIG_X86_SMAP}" ]; then
140 objtoolopt="${objtoolopt} --uaccess"
141 fi
142 info OBJTOOL ${1}
b1a1a1a0 143 tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
6804c1af
PZ
144 fi
145}
146
1f2bfbd0 147# Link of vmlinux
341dfcf8 148# ${1} - output file
618916a4 149# ${2}, ${3}, ... - optional extra .o files
1f2bfbd0
SR
150vmlinux_link()
151{
618916a4 152 local output=${1}
8f130512
MY
153 local objs
154 local libs
5df77ad6
MY
155 local ld
156 local ldflags
157 local ldlibs
1f2bfbd0 158
d7b0827f
LT
159 info LD ${output}
160
618916a4
AN
161 # skip output file argument
162 shift
163
8f130512
MY
164 if [ -n "${CONFIG_LTO_CLANG}" ]; then
165 # Use vmlinux.o instead of performing the slow LTO link again.
166 objs=vmlinux.o
167 libs=
168 else
169 objs="${KBUILD_VMLINUX_OBJS}"
170 libs="${KBUILD_VMLINUX_LIBS}"
171 fi
172
5df77ad6
MY
173 if [ "${SRCARCH}" = "um" ]; then
174 wl=-Wl,
175 ld="${CC}"
176 ldflags="${CFLAGS_vmlinux}"
177 ldlibs="-lutil -lrt -lpthread"
178 else
179 wl=
180 ld="${LD}"
181 ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
182 ldlibs=
183 fi
184
185 ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
186
af73d78b
KC
187 # The kallsyms linking does not need debug symbols included.
188 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
5df77ad6 189 ldflags="${ldflags} ${wl}--strip-debug"
af73d78b
KC
190 fi
191
5cc12472 192 if [ -n "${CONFIG_VMLINUX_MAP}" ]; then
5df77ad6 193 ldflags="${ldflags} ${wl}-Map=${output}.map"
5cc12472
RV
194 fi
195
5df77ad6
MY
196 ${ld} ${ldflags} -o ${output} \
197 ${wl}--whole-archive ${objs} ${wl}--no-whole-archive \
198 ${wl}--start-group ${libs} ${wl}--end-group \
199 $@ ${ldlibs}
1f2bfbd0
SR
200}
201
e83b9f55 202# generate .BTF typeinfo from DWARF debuginfo
341dfcf8
AN
203# ${1} - vmlinux image
204# ${2} - file to dump raw BTF data into
e83b9f55
AN
205gen_btf()
206{
341dfcf8 207 local pahole_ver
db16c1fe 208 local extra_paholeopt=
e83b9f55 209
581b31c3 210 if ! [ -x "$(command -v ${PAHOLE})" ]; then
2a67a6cc 211 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
341dfcf8 212 return 1
581b31c3
AN
213 fi
214
e83b9f55 215 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
21a85bd6
LB
216 if [ "${pahole_ver}" -lt "116" ]; then
217 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
341dfcf8 218 return 1
e83b9f55
AN
219 fi
220
341dfcf8 221 vmlinux_link ${1}
af73d78b 222
a0b8200d
AN
223 if [ "${pahole_ver}" -ge "118" ] && [ "${pahole_ver}" -le "121" ]; then
224 # pahole 1.18 through 1.21 can't handle zero-sized per-CPU vars
225 extra_paholeopt="${extra_paholeopt} --skip_encoding_btf_vars"
226 fi
db16c1fe
IL
227 if [ "${pahole_ver}" -ge "121" ]; then
228 extra_paholeopt="${extra_paholeopt} --btf_gen_floats"
229 fi
230
af73d78b 231 info "BTF" ${2}
ff2e6efd 232 LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${extra_paholeopt} ${1}
341dfcf8 233
90ceddcb
FS
234 # Create ${2} which contains just .BTF section but no symbols. Add
235 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
236 # deletes all symbols including __start_BTF and __stop_BTF, which will
237 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
238 # objcopy warnings: "empty loadable segment detected at ..."
239 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
240 --strip-all ${1} ${2} 2>/dev/null
241 # Change e_type to ET_REL so that it can be used to link final vmlinux.
242 # Unlike GNU ld, lld does not allow an ET_EXEC input.
243 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
e83b9f55 244}
1f2bfbd0 245
08beb669 246# Create ${2} .S file with all symbols from the ${1} object file
1f2bfbd0
SR
247kallsyms()
248{
1f2bfbd0
SR
249 local kallsymopt;
250
251 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
6895f97e 252 kallsymopt="${kallsymopt} --all-symbols"
1f2bfbd0
SR
253 fi
254
4d5d5664 255 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
c6bda7c9
RR
256 kallsymopt="${kallsymopt} --absolute-percpu"
257 fi
258
2213e9a6
AB
259 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
260 kallsymopt="${kallsymopt} --base-relative"
261 fi
262
08beb669
MY
263 info KSYMS ${2}
264 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
1f2bfbd0
SR
265}
266
8959e392
KC
267# Perform one step in kallsyms generation, including temporary linking of
268# vmlinux.
269kallsyms_step()
270{
271 kallsymso_prev=${kallsymso}
af73d78b
KC
272 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
273 kallsymso=${kallsyms_vmlinux}.o
08beb669 274 kallsyms_S=${kallsyms_vmlinux}.S
8959e392 275
d7b0827f 276 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
08beb669
MY
277 kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
278
279 info AS ${kallsyms_S}
280 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
281 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
282 -c -o ${kallsymso} ${kallsyms_S}
8959e392
KC
283}
284
1f2bfbd0
SR
285# Create map file with all symbols from ${1}
286# See mksymap for additional details
287mksysmap()
288{
289 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
290}
291
10916706 292sorttable()
1347a2ce 293{
10916706 294 ${objtree}/scripts/sorttable ${1}
1347a2ce
LT
295}
296
1f2bfbd0 297# Delete output files in case of error
1f2bfbd0
SR
298cleanup()
299{
341dfcf8 300 rm -f .btf.*
1f2bfbd0 301 rm -f .tmp_System.map
a8cccdd9 302 rm -f .tmp_initcalls.lds
38e89184 303 rm -f .tmp_symversions.lds
1f2bfbd0
SR
304 rm -f .tmp_vmlinux*
305 rm -f System.map
306 rm -f vmlinux
5cc12472 307 rm -f vmlinux.map
1f2bfbd0 308 rm -f vmlinux.o
0b956e20 309 rm -f .vmlinux.d
1f2bfbd0
SR
310}
311
1f2bfbd0
SR
312# Use "make V=1" to debug this script
313case "${KBUILD_VERBOSE}" in
314*1*)
315 set -x
316 ;;
317esac
318
319if [ "$1" = "clean" ]; then
320 cleanup
321 exit 0
322fi
323
324# We need access to CONFIG_ symbols
94cf8acc 325. include/config/auto.conf
1f2bfbd0 326
1f2bfbd0
SR
327# Update version
328info GEN .version
278ae604
MY
329if [ -r .version ]; then
330 VERSION=$(expr 0$(cat .version) + 1)
331 echo $VERSION > .version
1f2bfbd0 332else
278ae604
MY
333 rm -f .version
334 echo 1 > .version
1f2bfbd0
SR
335fi;
336
337# final build of init/
083bc0e1 338${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
1f2bfbd0 339
abac4c89 340#link vmlinux.o
abac4c89 341modpost_link vmlinux.o
6804c1af 342objtool_link vmlinux.o
abac4c89
NP
343
344# modpost vmlinux.o to check for section mismatches
a721588d 345${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
abac4c89 346
898490c0
AG
347info MODINFO modules.builtin.modinfo
348${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
8b41fc44
MY
349info GEN modules.builtin
350# The second line aids cases where multiple modules share the same object.
351tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
352 tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
898490c0 353
7fd78568 354btf_vmlinux_bin_o=""
341dfcf8 355if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
af73d78b
KC
356 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
357 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
da5fb182
SF
358 echo >&2 "Failed to generate BTF for vmlinux"
359 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
360 exit 1
341dfcf8
AN
361 fi
362fi
363
1f2bfbd0 364kallsymso=""
8959e392 365kallsymso_prev=""
1f2bfbd0
SR
366kallsyms_vmlinux=""
367if [ -n "${CONFIG_KALLSYMS}" ]; then
368
369 # kallsyms support
370 # Generate section listing all symbols and add it into vmlinux
371 # It's a three step process:
372 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
373 # but __kallsyms is empty.
374 # Running kallsyms on that gives us .tmp_kallsyms1.o with
375 # the right size
376 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
377 # the right size, but due to the added section, some
378 # addresses have shifted.
379 # From here, we generate a correct .tmp_kallsyms2.o
7e2b37c9
NP
380 # 3) That link may have expanded the kernel image enough that
381 # more linker branch stubs / trampolines had to be added, which
382 # introduces new names, which further expands kallsyms. Do another
383 # pass if that is the case. In theory it's possible this results
384 # in even more stubs, but unlikely.
385 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
386 # other bugs.
387 # 4) The correct ${kallsymso} is linked into the final vmlinux.
1f2bfbd0
SR
388 #
389 # a) Verify that the System.map from vmlinux matches the map from
390 # ${kallsymso}.
391
8959e392
KC
392 kallsyms_step 1
393 kallsyms_step 2
1f2bfbd0 394
7e2b37c9 395 # step 3
8959e392
KC
396 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
397 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
7e2b37c9
NP
398
399 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
8959e392 400 kallsyms_step 3
1f2bfbd0
SR
401 fi
402fi
403
d7b0827f 404vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
e83b9f55 405
c9a0f3b8 406# fill in BTF IDs
017dab34
JO
407if [ -n "${CONFIG_DEBUG_INFO_BTF}" -a -n "${CONFIG_BPF}" ]; then
408 info BTFIDS vmlinux
409 ${RESOLVE_BTFIDS} vmlinux
c9a0f3b8
JO
410fi
411
10916706
SZ
412if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
413 info SORTTAB vmlinux
f14bf6a3
SZ
414 if ! sorttable vmlinux; then
415 echo >&2 Failed to sort kernel tables
416 exit 1
417 fi
1347a2ce
LT
418fi
419
1f2bfbd0
SR
420info SYSMAP System.map
421mksysmap vmlinux System.map
422
423# step a (see comment above)
424if [ -n "${CONFIG_KALLSYMS}" ]; then
425 mksysmap ${kallsyms_vmlinux} .tmp_System.map
426
427 if ! cmp -s System.map .tmp_System.map; then
5369f550 428 echo >&2 Inconsistent kallsyms data
367e43c5 429 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
1f2bfbd0
SR
430 exit 1
431 fi
432fi
0b956e20
RV
433
434# For fixdep
435echo "vmlinux: $0" > .vmlinux.d